#!/usr/local/bin/python
#
#   dijkstra.py
#
from sys import maxsize, argv
import sarg
exec("import %s as graph" % sarg.Str("graph","graph_1"))

class Node :
    def __init__ (self, name, pos, nbrs=[]) :
        self.name = name
        self.pos  = pos
        self.nbrs = []        # list of (other_Node, distance) tuples
        self.reset()

    def reset(self) :
        self.srcDist = maxsize # tentative distance to source unknown
        self.prev = None      # 1st node going back to source
        self.state = 0        # distance is 0=unknown, 1=tentative or 2=fixed

    def __str__(self) :
        nbrs = [nbr.name  for nbr,dist in self.nbrs]
        return "%s: %s" % (self.name, nbrs)

def findPaths(display, nodes, source) :  # node names
    "implements the dijkstra algorithm. Updates nodes dist & prev attributes"
    for node in nodes : node.reset()
    source.srcDist = 0
    source.state   = 1
    display("Initial Configuration", nodes)
    while True :
        best = maxsize; hub = None
        for test in nodes :
            if test.state != 2 and test.srcDist < best :
                best = test.srcDist
                hub  = test
        if not hub : break                # all nodes in final state
        hub.state = 2                     # set hub as final
        display("Node "+hub.name+" set to fixed state",nodes)
        for nbr,incDist in hub.nbrs :
            if nbr.state == 2 : continue  # already finalized
            if nbr.prev == hub: continue  # no looking back !
            if hub.srcDist+incDist < nbr.srcDist :
                if nbr.state == 0 : action = "sets tentative distance to"
                else              : action = "overrides distance to"
                nbr.state = 1  # tenative capture
                nbr.srcDist  = hub.srcDist+incDist
                nbr.prev  = hub
            else :
                action = "can't improve distance to source"
            banner = "%s %s %s" % (hub.name,action,nbr.name)
            display(banner,nodes)
    display("Shortest Paths from %s" % source.name, nodes)

def main()  :
    srcNode = sarg.Str("source","S")    # default
    output  = sarg.Str("output","plot")
    nodes, nodeDict = graph.makeGraph(Node)
    if output == "plot" :
        from displayPlot import display_frame, display_close
    else :
        from displayText import display_frame, display_close
    findPaths(display_frame, nodes, nodeDict[srcNode])
    display_close()

if __name__ == "__main__" : main()
